"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const rest_object_1 = require("./rest-object");
const ts_md5_1 = require("ts-md5");
class Package extends rest_object_1.default {
    constructor(name, versions, packageJson, scope) {
        super();
        this.entityIdentifier = "package";
        this.name = name;
        this.scope = scope;
        this.versions = versions;
        this.packageJson = packageJson;
    }
    getName() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.name;
        });
    }
    getScope() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.scope;
        });
    }
    toObject() {
        return __awaiter(this, void 0, void 0, function* () {
            return {
                id: ts_md5_1.Md5.hashStr(this.scope ? this.name + "/" + this.scope : this.name),
                name: this.name,
                scope: this.scope,
                versions: this.versions,
                packageJson: this.packageJson
            };
        });
    }
}
exports.default = Package;
//# sourceMappingURL=package.js.map