"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const package_1 = require("./entities/package");
class PackageRepository {
    constructor(storage) {
        this.storage = storage;
    }
    getPackages() {
        return __awaiter(this, void 0, void 0, function* () {
            const pkgs = [];
            const packages = yield this.storage.getPackageListing();
            for (const key of packages.keys()) {
                if (key.charAt(0) === "@") {
                    for (const k of Object.keys(packages.get(key))) {
                        try {
                            pkgs.push(new package_1.default(k, packages.get(key)[k], yield this.storage.getPackageJson({ name: k, scope: key }), key));
                        }
                        catch (err) { }
                    }
                }
                else {
                    try {
                        pkgs.push(new package_1.default(key, packages.get(key), yield this.storage.getPackageJson({
                            name: key
                        })));
                    }
                    catch (err) { }
                }
            }
            return pkgs;
        });
    }
    getPackage(name, scope) {
        return __awaiter(this, void 0, void 0, function* () {
            const pkgJson = yield this.storage.getPackageJson({ name, scope });
            return new package_1.default(name, Object.keys(pkgJson.versions), pkgJson, scope);
        });
    }
}
exports.default = PackageRepository;
//# sourceMappingURL=package-repository.js.map