"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class Access {
    constructor(auth, isPublic = false) {
        this.auth = auth;
        this.isPublic = isPublic;
    }
    can(access) {
        return (req, res, next) => __awaiter(this, void 0, void 0, function* () {
            if (this.isPublic) {
                return next();
            }
            if (typeof req.headers.authorization === "string") {
                try {
                    if (!req.headers.authorization.startsWith("Bearer ")) {
                        res.status(400).send({ message: "Invalid authorization header" });
                        return;
                    }
                    const shouldBeAbleTo = yield this.auth.shouldBeAbleTo(access, req.params.package, req.headers.authorization);
                    if (shouldBeAbleTo) {
                        return next();
                    }
                    else {
                        res.status(401).send({ message: "Unauthorized" });
                        return;
                    }
                }
                catch (err) {
                }
            }
            res.status(401).send({ message: "Unauthorized" });
        });
    }
}
exports.default = Access;
//# sourceMappingURL=access.js.map