export default abstract class AuthProvider {
    abstract userLogin(username: string, password: string, email?: string): Promise<string>;
    abstract userAdd(username: string, password: string, email: string): Promise<string>;
    abstract userRemove(username: string, password: string): Promise<boolean>;
    abstract userLogout(token: string): Promise<boolean>;
    abstract verifyToken(token: string): Promise<string>;
}
