import AuthProvider from "./auth-provider";
import IFS from "../storage/filesystem/fs-interface";
export default class JsonProvider extends AuthProvider {
    private readonly dbLocation;
    private settings;
    private users;
    private tokens;
    private fs;
    constructor(config: Map<string, any>, fs: IFS);
    userLogin(username: string, password: string): Promise<string>;
    userAdd(username: string, password: string, email: string): Promise<string>;
    userRemove(username: string, password: string): Promise<boolean>;
    userLogout(token: string): Promise<boolean>;
    private updateUserDB;
    private updateTokenDB;
    private initTokenDB;
    private initUserDB;
    verifyToken(token: string): Promise<string>;
    private mapToObject;
    private objToMap;
    storageInit(): Promise<boolean>;
    private static generateToken;
}
