"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const auth_provider_1 = require("./auth/auth-provider");
exports.AuthProvider = auth_provider_1.default;
const json_provider_1 = require("./auth/json-provider");
const init_1 = require("./init");
class ApNpmApplication {
    constructor(config, auth) {
        this.container = init_1.default(config);
        if (typeof auth !== "undefined") {
            this.authProvider = auth;
        }
        else {
            const map = new Map(Object.entries(config));
            this.authProvider = new json_provider_1.default(map, this.container.get("fs"));
        }
    }
    listen() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.authProvider instanceof json_provider_1.default)
                yield this.authProvider.storageInit();
            this.container.set("auth", this.authProvider);
            const commandServe = this.container.get("command-serve");
            return commandServe.run();
        });
    }
}
exports.default = ApNpmApplication;
//# sourceMappingURL=index.js.map