/// <reference types="node" />
import Container from "./util/container";
import { Url } from "url";
export default function Init(config: IConfig): Container;
export interface IConfig {
    workDir: string;
    storage: {
        directory: string;
    };
    port: number;
    hostname: string;
    proxyEnabled: boolean;
    proxyUrl: Url;
    auth: {
        users: {
            canPublish: boolean;
            canAccess: boolean;
        };
        register: true;
        public: false;
        remove: true;
    };
    ssl: {
        enabled: boolean;
        key: string;
        cert: string;
    };
}
