"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const container_1 = require("./util/container");
const storage_init_1 = require("./init/storage-init");
const routes_init_1 = require("./init/routes-init");
const auth_init_1 = require("./init/auth-init");
const command_init_1 = require("./init/command-init");
const util_init_1 = require("./init/util-init");
const api_init_1 = require("./init/api-init");
const logger_1 = require("./util/logger");
const process_1 = require("process");
function Init(config) {
    const container = new container_1.default();
    container.set("config", function () {
        const map = new Map();
        const object = config;
        Object.keys(object).forEach(key => {
            map.set(key, object[key]);
        });
        return map;
    });
    container.set("logger", function () {
        return new logger_1.default(process_1.stdout);
    });
    storage_init_1.default(container);
    auth_init_1.default(container);
    command_init_1.default(container);
    api_init_1.default(container);
    util_init_1.default(container);
    routes_init_1.default(container);
    return container;
}
exports.default = Init;
//# sourceMappingURL=init.js.map