"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const package_get_json_1 = require("../routes/package-get-json");
const package_publish_1 = require("../routes/package-publish");
const package_get_1 = require("../routes/package-get");
const package_delete_1 = require("../routes/package-delete");
const package_get_dist_tags_1 = require("../routes/package-get-dist-tags");
const package_delete_dist_tags_1 = require("../routes/package-delete-dist-tags");
const package_add_dist_tags_1 = require("../routes/package-add-dist-tags");
const search_1 = require("../routes/search");
const package_proxy_1 = require("../routes/package-proxy");
const audit_proxy_1 = require("../routes/audit-proxy");
function default_1(container) {
    container.set("route-package-get-json", function () {
        return new package_get_json_1.default(container.get("storage"), container.get("route-package-proxy"), container.get("config").get("proxyEnabled"));
    });
    container.set("route-package-publish", function () {
        return new package_publish_1.default(container.get("storage"), container.get("validator"));
    });
    container.set("route-package-get", function () {
        return new package_get_1.default(container.get("storage"));
    });
    container.set("route-package-delete", function () {
        return new package_delete_1.default(container.get("storage"), container.get("validator"), container.get("config"));
    });
    container.set("route-package-get-dist-tags", function () {
        return new package_get_dist_tags_1.default(container.get("storage"));
    });
    container.set("route-package-delete-dist-tags", function () {
        return new package_delete_dist_tags_1.default(container.get("storage"));
    });
    container.set("route-package-add-dist-tags", function () {
        return new package_add_dist_tags_1.default(container.get("storage"));
    });
    container.set("route-search", function () {
        return new search_1.default(container.get("storage"));
    });
    container.set("route-package-proxy", function () {
        return new package_proxy_1.default(container.get("config").get("proxyUrl"), container.get("axios"));
    });
    container.set("route-audit-proxy", function () {
        return new audit_proxy_1.default(container.get("config").get("proxyUrl"), container.get("axios"), container.get("config").get("proxyAudit"));
    });
}
exports.default = default_1;
//# sourceMappingURL=routes-init.js.map