"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const route_1 = require("./route");
class ApiAuthenticate extends route_1.default {
    constructor(auth) {
        super();
        this.auth = auth;
    }
    process(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!req.body.username || !req.body.password || !req.body.email) {
                res.status(400).send({ message: "Invalid request" });
                return;
            }
            try {
                const token = yield this.auth.userLogin(req.body.username, req.body.password, req.body.email);
                res.status(200).send({ token });
            }
            catch (err) {
                res.status(401).send({ message: "Invalid username or password" });
            }
        });
    }
}
exports.default = ApiAuthenticate;
//# sourceMappingURL=api-authenticate.js.map