"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const route_1 = require("./route");
class ApiPackage extends route_1.default {
    constructor(repository) {
        super();
        this.repository = repository;
    }
    process(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            if (req.params.package !== undefined) {
                try {
                    const pkg = yield this.repository.getPackage(req.params.package, req.params.scope);
                    res.status(200).send({
                        package: yield pkg.toObject()
                    });
                }
                catch (err) {
                    res.status(404).send({
                        message: "Package not found"
                    });
                }
            }
            else {
                try {
                    const pkgs = yield this.repository.getPackages();
                    const pkgsObjs = [];
                    yield Promise.all(pkgs.map((pkg) => __awaiter(this, void 0, void 0, function* () {
                        pkgsObjs.push(yield pkg.toObject());
                    })));
                    res.status(200).send({
                        packages: pkgsObjs
                    });
                }
                catch (err) {
                    res.status(500).send({ ok: false, message: "Internal server error" });
                }
            }
        });
    }
}
exports.default = ApiPackage;
//# sourceMappingURL=api-package.js.map