"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const route_1 = require("./route");
class AuditProxy extends route_1.default {
    constructor(proxyUrl, client, enabled) {
        super();
        this.proxyUrl = proxyUrl;
        this.enabled = enabled;
        this.client = client;
    }
    process(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.enabled) {
                try {
                    const response = yield this.client.post(this.proxyUrl.endsWith("/")
                        ? this.proxyUrl + req.url
                        : this.proxyUrl + "/" + req.url, req.body);
                    res.status(response.status).send(response.data);
                    return;
                }
                catch (err) { }
            }
            res.status(500).send({ ok: false, message: "Internal server error" });
        });
    }
}
exports.default = AuditProxy;
//# sourceMappingURL=audit-proxy.js.map