"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const route_1 = require("./route");
class AuthWhoami extends route_1.default {
    constructor(auth) {
        super();
        this.auth = auth;
    }
    process(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            if (req.headers.authorization) {
                const token = req.headers.authorization.substr(7);
                try {
                    const user = yield this.auth.verifyToken(token);
                    res.status(200).send({ username: user });
                    return;
                }
                catch (err) { }
            }
            res.status(401).send("Invalid user");
        });
    }
}
exports.default = AuthWhoami;
//# sourceMappingURL=auth-whoami.js.map