"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const route_1 = require("./route");
const semver = require("semver");
class PackageAddDistTags extends route_1.default {
    constructor(storage) {
        super();
        this.storage = storage;
    }
    process(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            const packageName = req.params.package;
            const packageScope = req.params.scope;
            const distTag = req.params.tag;
            if (typeof req.body !== "string" || !semver.valid(req.body)) {
                res.status(400).send({ message: "Invalid version for dist tag given" });
                return;
            }
            const distTagVersion = req.body;
            try {
                const packageJson = yield this.storage.getPackageJson({
                    name: packageName,
                    scope: packageScope
                });
                if (typeof packageJson === "object" &&
                    typeof packageJson.versions[distTagVersion] === "object") {
                    packageJson["dist-tags"][distTag] = distTagVersion;
                    const result = yield this.storage.updatePackageJson({ name: packageName, scope: packageScope }, packageJson);
                    if (result) {
                        res.status(200).send({ ok: true, message: "dist-tags added" });
                    }
                    else {
                        res
                            .status(404)
                            .send({ ok: true, message: "Could not get dist-tags" });
                    }
                    return;
                }
            }
            catch (err) { }
            res
                .status(404)
                .send({
                ok: false,
                message: "Could not find package or version of package"
            });
        });
    }
}
exports.default = PackageAddDistTags;
//# sourceMappingURL=package-add-dist-tags.js.map