"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const route_1 = require("./route");
class PackageDeleteDistTags extends route_1.default {
    constructor(storage) {
        super();
        this.storage = storage;
    }
    process(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            const packageName = req.params.package;
            const packageScope = req.params.scope;
            const distTag = req.params.tag;
            try {
                const packageJson = yield this.storage.getPackageJson({
                    name: packageName,
                    scope: packageScope
                });
                if (typeof packageJson === "object") {
                    delete packageJson["dist-tags"][distTag];
                    const result = yield this.storage.updatePackageJson({
                        name: packageName,
                        scope: packageScope
                    }, packageJson);
                    if (result === true) {
                        res.status(200).send({
                            ok: true,
                            message: "dist-tags updated"
                        });
                    }
                    else {
                        res.status(404).send({ message: "Could not update dist-tags" });
                    }
                    return;
                }
            }
            catch (err) { }
            res.status(404).send({ message: "Could not get dist-tags" });
        });
    }
}
exports.default = PackageDeleteDistTags;
//# sourceMappingURL=package-delete-dist-tags.js.map