"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const route_1 = require("./route");
class PackageGetJson extends route_1.default {
    constructor(storage, proxy, proxyEnabled) {
        super();
        this.storage = storage;
        this.proxy = proxy;
        this.proxyEnabled = proxyEnabled;
    }
    process(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const packageJson = yield this.storage.getPackageJson({
                    name: req.params.package,
                    scope: req.params.scope
                });
                if (typeof packageJson === "object") {
                    res.status(200).send(packageJson);
                    return;
                }
                else {
                    res.status(404).send({ ok: false, message: "Package not found" });
                    if (!this.proxyEnabled) {
                        return;
                    }
                }
            }
            catch (err) { }
            if (this.proxyEnabled) {
                yield this.proxy.process(req, res);
                return;
            }
            res.status(500).send({ ok: false, message: "Internal server error" });
        });
    }
}
exports.default = PackageGetJson;
//# sourceMappingURL=package-get-json.js.map