"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const route_1 = require("./route");
class PackageProxy extends route_1.default {
    constructor(proxyUrl, client) {
        super();
        this.proxyUrl = proxyUrl;
        this.client = client;
    }
    process(req, res) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const scope = req.params.scope;
                const name = req.params.package;
                const urlPath = scope ? `${scope}/${name}` : `${name}`;
                const url = this.proxyUrl.endsWith("/")
                    ? this.proxyUrl + urlPath
                    : this.proxyUrl + "/" + urlPath;
                if (url !== undefined) {
                    const response = yield this.client.get(url);
                    res.status(response.status).send(response.data);
                    return;
                }
            }
            catch (err) {
            }
            res.status(500).send("Internal server error");
        });
    }
}
exports.default = PackageProxy;
//# sourceMappingURL=package-proxy.js.map