/// <reference types="node" />
import Logger from "../../util/logger";
import IFS from "./fs-interface";
import { default as IStorageProvider, IRequest } from "../storage-provider";
export default class Filesystem implements IStorageProvider {
    private config;
    private readonly logger;
    private readonly storageLocation;
    private readonly fs;
    constructor(config: Map<string, any>, logger: Logger, fs: IFS);
    removePackage(request: IRequest): Promise<boolean>;
    removePackageVersion(request: IRequest): Promise<boolean>;
    writeNewPackage(request: IRequest, packageData: any): Promise<boolean>;
    writePackage(request: IRequest, packageData: any): Promise<boolean>;
    getPackage(request: IRequest): Promise<Buffer>;
    getPackageJson(request: IRequest): Promise<any>;
    isPackageAvailable(request: IRequest): Promise<boolean>;
    updatePackageJson(request: IRequest, packageJson: any): Promise<boolean>;
    getPackageListing(): Promise<Map<string, any>>;
}
