"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
exports.default = (fs, request, storageLocation) => __awaiter(this, void 0, void 0, function* () {
    const packageName = request.name;
    const packageScope = request.scope;
    const jsonPath = packageScope
        ? path_1.join(storageLocation, packageScope, packageName, "package.json")
        : path_1.join(storageLocation, packageName, "package.json");
    const exists = yield fs.exists(jsonPath);
    if (exists) {
        return JSON.parse(yield fs.readFile(jsonPath));
    }
    else {
        throw Error(`package.json of ${packageScope ? packageScope + "/" + packageName : packageName} does not exist`);
    }
});
//# sourceMappingURL=get-package-json.js.map