"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const getVersions = function (fs, packageLocation) {
    return __awaiter(this, void 0, void 0, function* () {
        const versionArray = [];
        const packageJson = JSON.parse(yield fs.readFile(path.join(packageLocation, "package.json")));
        const versionsObject = packageJson.versions;
        if (versionsObject) {
            for (const key in versionsObject) {
                if (versionsObject.hasOwnProperty(key)) {
                    versionArray.push(key);
                }
            }
        }
        return versionArray;
    });
};
function default_1(fs, storageLocation) {
    return __awaiter(this, void 0, void 0, function* () {
        const storageListing = new Map();
        const parts = yield fs.readdir(storageLocation);
        yield Promise.all(parts.map((part) => __awaiter(this, void 0, void 0, function* () {
            if (part.indexOf("@") !== -1) {
                if (!storageListing.has(part)) {
                    storageListing.set(part, {});
                }
                const scopedParts = yield fs.readdir(path.join(storageLocation, part));
                if (scopedParts.length === 0) {
                    storageListing.delete(part);
                    return;
                }
                for (let i = 0; i < scopedParts.length; i++) {
                    const scopedLocation = path.join(storageLocation, part, scopedParts[i]);
                    if ((yield fs.lstat(scopedLocation)).isDirectory()) {
                        try {
                            storageListing.get(part)[scopedParts[i]] = yield getVersions(fs, scopedLocation);
                        }
                        catch (err) { }
                    }
                }
            }
            else {
                const location = path.join(storageLocation, part);
                try {
                    storageListing.set(part, yield getVersions(fs, location));
                }
                catch (err) { }
            }
        })));
        return storageListing;
    });
}
exports.default = default_1;
//# sourceMappingURL=get-package-listing.js.map