"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Container {
    constructor() {
        this.services = new Map();
        this.resolved = new Map();
    }
    set(name, service) {
        this.services.set(name, service);
    }
    has(name) {
        return this.services.has(name);
    }
    get(name) {
        if (this.resolved.has(name)) {
            return this.resolved.get(name);
        }
        if (this.services.has(name)) {
            let service = this.services.get(name);
            if (typeof service === "function") {
                service = service.call();
            }
            this.resolved.set(name, service);
            return this.resolved.get(name);
        }
        throw new Error(`Cannot find service: ${name}`);
    }
}
exports.default = Container;
//# sourceMappingURL=container.js.map