"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const colors = require("colors");
class Logger {
    constructor(stream) {
        this.stream = stream;
    }
    log(...messages) {
        messages.forEach((message) => {
            this.write(message);
        });
    }
    info(...messages) {
        messages.forEach((message) => {
            this.write(colors.green(message));
        });
    }
    warn(...messages) {
        messages.forEach((message) => {
            this.write(colors.yellow(message));
        });
    }
    error(...messages) {
        messages.forEach((message) => {
            this.write(colors.red(message));
        });
    }
    debug(...messages) {
        messages.forEach((message) => {
            this.write(colors.blue(message));
        });
    }
    write(message) {
        if (this.stream.writable) {
            this.stream.write(message);
        }
    }
}
exports.default = Logger;
//# sourceMappingURL=logger.js.map