"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const semver = require("semver");
class Validator {
    constructor(storage) {
        this.storage = storage;
    }
    isVersionHigher(request, distTag) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!request.version) {
                throw Error("No version given to check");
            }
            const pkgJson = yield this.storage.getPackageJson(request);
            return semver.satisfies(request.version, ">" + pkgJson["dist-tags"][distTag]);
        });
    }
    hasDistTag(request, distTag) {
        return __awaiter(this, void 0, void 0, function* () {
            const pkgJson = yield this.storage.getPackageJson(request);
            return !!pkgJson["dist-tags"][distTag];
        });
    }
}
exports.default = Validator;
//# sourceMappingURL=validator.js.map